config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root "articles#index"

  resources :articles

  resources :categories
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
  has_one_attached :image

  belongs_to :category
  belongs_to :user

  validates :description, :category_id, presence: true

  delegate :description, to: :category, prefix: true
  delegate :email, to: :user, prefix: true
end

app/models/category.rb
class Category < ApplicationRecord
  has_many :articles
  belongs_to :user

  delegate :email, to: :user, prefix: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :articles
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :authenticate_user!
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  def index
    @articles = Article.order(params[:sort])
  end

  def show
    @article = Article.find(params[:id])
  end

  def new
    @article = Article.new
  end

  def create
    @article = Article.new(article_params)
    @article.user_id = current_user.id

    if @article.save
      redirect_to @article
    else
      render :new
    end
  end

  def edit
    @article = Article.find(params[:id])
  end

  def update
    @article = Article.find(params[:id])

    if @article.update(article_params)
      @article.user_id = current_user.id

      redirect_to @article
    else
      render :edit
    end
  end

  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    redirect_to root_path
  end

  private
    def article_params
      params.require(:article).permit(:description, :image, :status, :category_id)
    end
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  def index
    @categories = Category.all
  end

  def show
    @category = Category.find(params[:id])
  end

  def new
    @category = Category.new
  end

  def create
    @category = Category.new(category_params)
    @category.user_id = current_user.id


    if @category.save
      redirect_to @category
    else
      render :new
    end
  end

  def edit
    @category = Category.find(params[:id])
  end

  def update
    @category = Category.find(params[:id])
    @category.user_id = current_user.id

    if @category.update(category_params)
      redirect_to @category
    else
      render :edit
    end
  end

  def destroy
    @category = Category.find(params[:id])
    @category.destroy

    redirect_to root_path
  end

  private
    def category_params
      params.require(:category).permit(:description, :status)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/articles/_form.html.erb
<%= form_with model: article do |form| %>
  <div>
    <%= form.label :description %><br>
    <%= form.text_area :description %>
    <% article.errors.full_messages_for(:description).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>

  <br>
  <div>
    <%= form.label :image %><br>
    <%= form.file_field :image %>
  </div>

  <br>
  <div>
    <%= form.label :status %><br>
    <%= form.select("status", [["Active", 1],["Inactive", 2]], { include_blank: true }) %>
  </div>

  <br>
  <div>
    <%= form.label :category_id %><br>
    <%= form.select("category_id", Category.all.collect {|c| [c.description, c.id ] }, { include_blank: true }) %>
    <% article.errors.full_messages_for(:category_id).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>

  <br>
  <div>
    <%= form.submit class: "btn btn-primary" %>
  </div>
<% end %>

app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<%= render "form", article: @article %>

<br>
<%= link_to "Articles", articles_path(@articles) %>

app/views/articles/index.html.erb
<h1>Articles</h1>

<table id="dtBasicExample" class="table table-striped table-bordered table-sm" cellspacing="0" width="100%">
  <thead>
    <tr>
      <th><%= link_to "Description", :sort => "description"%> </th>
      <th><%= link_to "Image", :sort => "image"%> </th>
      <th><%= link_to "Status", :sort => "status"%> </th>
      <th><%= link_to "Category Description", :sort => "category_id"%> </th>
      <th><%= link_to "User", :sort => "user_id"%> </th>
    </tr>
  </thead>

  <tbody>
    <% @articles.each do |article| %>
      <tr>
        <td>
          <%= link_to article.description, article %>
        </td>
        <td>
          <%= article.image.filename %>
        </li>
        <td>
          <%= article.status == "1" ? "Active" : "Inactive" %></p>
        </td>
        <td>
          <%= article.category_description %>
        </td>
        <td>
          <%= article.user_email %>
        </td>
      </tr>

    <% end %>
  </tbody>
</table>

<br>
<%= link_to "New Article", new_article_path %>

<br>
<%= link_to "Categories", categories_path %>

app/views/articles/new.html.erb
<h1>New Article</h1>

<%= render "form", article: @article %>

<br>
<%= link_to "Articles", articles_path(@articles) %>

app/views/articles/show.html.erb
<h1><%= @article.description %></h1>

<p>Image: 
    <% if @article.image.attached? %>
        <%= link_to @article.image.filename, rails_blob_path(@article.image, disposition: 'attachment') %> </p>
    <% end %>


<p>Status: <%= @article.status == "1" ? "Active" : "Inactive" %></p>

<p>Category: <%= @article.category_description %></p>

<p>User: <%= @article.user_email %></p>

<%= link_to "Edit", edit_article_path(@article) %>

<%= link_to "Destroy", article_path(@article),
                  method: :delete,
                  data: { confirm: "Are you sure?" } %>


<%= link_to "Articles", articles_path(@articles) %>

app/views/categories/_form.html.erb
<%= form_with model: category do |form| %>
  <div>
    <%= form.label :description %><br>
    <%= form.text_field :description %>
    <% category.errors.full_messages_for(:description).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>

  <div>
    <%= form.label :status %><br>
    <%= form.text_field :status %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h1>Edit Category</h1>

<%= render "form", category: @category %>

app/views/categories/index.html.erb
<h1>Categories</h1>

<table>
  <tr>
    <th class= "col-4">Description</th>
    <th class= "col-2">Status</th>
    <th class= "col-2">User</th>
  </tr>

  <% @categories.each do |category| %>
    <tr>
      <td>
        <%= link_to category.description, category %>
      </td>
      <td>
        <%= category.status %>
      </td>
      <td>
        <%= category.user_email %>
      </td>
    </tr>

  <% end %>
</table>

<br>
<%= link_to "New Category", new_category_path %>
<%= link_to "Articles", articles_path %>

app/views/categories/new.html.erb
<h1>New Category</h1>

<%= render "form", category: @category %>

app/views/categories/show.html.erb
<h1><%= @category.description %></h1>

<p>Status: <%= @category.status %></p>

<p>User: <%= @category.user_email %></p>

<%= link_to "Edit", edit_category_path(@category) %>

<%= link_to "Destroy", category_path(@category),
                  method: :delete,
                  data: { confirm: "Are you sure?" } %>

<%= link_to "Categories", categories_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>News</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <% if notice %>
      <p class="alert alert-success"><%= notice %></p>
    <% end %>
    <% if alert %>
      <p class="alert alert-danger"><%= alert %></p>
    <% end %>

    <div class = "p-2">
      <p class="navbar-text float-right">
        <% if user_signed_in? %>
          Logged in as <strong><%= current_user.email %></strong>.
          <%= link_to 'Edit profile', edit_user_registration_path, :class => 'navbar-link' %> |
          <%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
        <% else %>
          <%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link'  %> |
          <%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
        <% end %>
      </p>
      <%= yield %>
    </div>
  </body>
</html>